Page MenuHomePhabricator

Enlarging the default thumb size on Dutch Wikipedia
Open, NormalPublic

Description

Background: A few years the visual editor was for the first time enabled on various Wikipedia's including the Dutch Wikipedia. The Dutch community noticed a series of issues with the software and asked to put the employment of the visual editor on hold for the Dutch Wikipedia.

After some years time, almost all the issues we noticed were solved, besides one and that is related to the template largethumb, used on the Dutch Wikipedia to line out images straight under the infoboxes (that all have the same width). However, in the visual editor this causes multiple empty rows on top of the page that editors try to remove, and with this hiddenly remove images.

At Wikimania's we have been asking if also this issue can be solved, and going through all the options and difficulties, we learned that the easiest way to deal with this issue is to get the standard thumb size of 220px enlarged to 260px. This solves the issue of the largethumb (as it becomes obsolete), it also solves the issue that many users experience the default thumb size as too small.

Recently: We recently had some complaints of people noticing that editing is still hard without the visual editor and it was concluded that we need to enlarge the default thumb size of 220px with 40px. When this is implemented, the community will discuss how the visual editor can be implemented.

So our request: please enlarge the default thumb size to 260px on the Dutch Wikipedia.

Thank you!

Event Timeline

Romaine created this task.Feb 2 2019, 4:24 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptFeb 2 2019, 4:24 PM
Mbch331 added a subscriber: Mbch331.Feb 2 2019, 6:42 PM
Romaine updated the task description. (Show Details)Feb 2 2019, 9:10 PM

@Romaine, thank you for filing this. I have read the linked discussion. Romaine made this suggestion two weeks ago. There was no opposition, and several people agreed. I believe that this is ready to implement as soon as possible.

Ammarpad claimed this task.Feb 10 2019, 4:16 PM
Ammarpad triaged this task as Normal priority.

Nothing seems to have happened, we are still waiting...

The discussion automatically has been archived by the archivebot and can be found here now: https://nl.wikipedia.org/wiki/Wikipedia:De_kroeg/Archief/20190209

Change 490395 had a related patch set uploaded (by Ammarpad; owner: Ammarpad):
[operations/mediawiki-config@master] Increase default thumb size to 260px on Dutch Wikipedia

https://gerrit.wikimedia.org/r/490395

Nothing seems to have happened, we are still waiting...

Hi, we are on phabricator :) tasks can get weeks to month to be concluded.

Ejs-80 added a subscriber: Ejs-80.Feb 14 2019, 3:34 PM

Nothing seems to have happened, we are still waiting...

@Romaine: See https://www.mediawiki.org/wiki/Gerrit/Tutorial how you can propose software changes (patches).

@Ammarpad seems to have already written the patch. What else needs to be done?

@Ammarpad seems to have already written the patch. What else needs to be done?

Someone needs to give it a +2 on Gerrit so it gets merged

Jdforrester-WMF added a subscriber: Jdforrester-WMF.

Has this been signed off by SRE and Performance? The last times people wanted to change the default thumb size were I think vetoed because of concerns about causing a server stampede with all the requests for new thumb sizes that weren't previously requested and so weren't generated and cached.

Krinkle added subscribers: Gilles, Krinkle.EditedMar 15 2019, 7:38 PM

In wmf-config, wgUploadThumbnailRenderMap is currently set the same for all (public) wikis, as:

[ 320, 640, 800, 1024, 1280, 1920 ]

This does not contain 220 (the current default for nlwiki). Which means in terms of rendering thumbnails after first use in an nlwiki article, I suspect it would be the same as today (it isn't pre-rendered).

In terms of server load, I don't know if there's concern with 220 vs 260. It's possible that 220 may or may not align with a common non-default size used elsewhere by other wikis and that 260 would still make it cause extra load. The opposite is unlikely to be true given that other wikis only have 200, 250 and 300 as options. So 260 is definitely "unique".

Having said that, I don't know how significant that load would be. I'll leave it to @Gilles to speak to that.

Also, it's worth noting that it's quite possible that this change is mostly no-op, because the majority of popular articles on Dutch Wikipedia don't use the default thumbnail size. They use {{largethumb}} instead, which is set to 260px. That's in fact the reason they want to change the default, so that this template is no longer needed, and by extent, VisualEditor easier to use. Depending on how true this claim really is (that most popular articles do this already), it may or may not be a significant change.

Someone needs to give it a +2 on Gerrit so it gets merged

Precisely no, that's more complicated, see https://wikitech.wikimedia.org/wiki/Deployments :)

Gilles added a comment.EditedMar 18 2019, 9:30 AM

Stats to consider, as of May 2017 (last time we ran this analysis):

  • 220px: 15th most common thumbnail size (with 11,842,737 thumbnails)
  • 440px (2x density): 29th (7,110,046)
  • 260px: 76th (1,591,095)
  • 520px: 127th (944,399)
  • 250px: 17th (11,259,575)
  • 500px: 18th (11,243,190)
  • 300px: 9th (17,296,731)
  • 600px: 20th (11,023,267)

I don't know about the layout implications, but in terms of performance, 300px and 250px that are close in terms of size are much better options than 260px. It's always better to pick sizes that are popular with other (probably bigger) wikis. As @Krinkle pointed out, if you really want optimal performance and are ok with diverging in terms of layout/size, then 320 is the best choice, since it gets prerendered on new uploads (and 640 too).

Now, regardless of which size you want to switch to, you should do it in this order:

  • convert the top 100 or top 1000 articles in terms of traffic to the new size via wikitext
  • convert articles known to contain a lot of images via wikitext
  • change the default for the wiki

With all those precautions in place, changing the default thumbnail size should be fine. nlwiki only represents 1% of our traffic.

kchapman moved this task from Inbox to Radar on the Performance-Team board.Mar 18 2019, 9:04 PM
kchapman edited projects, added Performance-Team (Radar); removed Performance-Team.
Ciell added a subscriber: Ciell.Apr 14 2019, 2:46 PM
Krinkle added a comment.EditedApr 14 2019, 5:56 PM

To do:


  • Update top 100 articles from last month on nl.wikipedia.org, and make them the same as they would be after changing the default.

Any [[File:]] that has no px-size and no {{largethumb}}, should have {{largethumb}} added. This might be possible to do with a bot (or AWB).

See list from Page view API (site: nl.wikipedia.org, Turn on "Whole month").


  • Update pages with over 250 images on nl.wikipedia.org, and make them the same as if the default was changed.

Any [[File:]] that has no px-size and no {{largethumb}}, should have {{largethumb}} added.

You can ignore infoboxes, templates, and <gallery>.

I made a query at https://quarry.wmflabs.org/query/35149 which shows there are 162 pages on nl.wikipedia.org that have "> 250 image links" (not including audio files, not including user sub pages and talk pages).


Change 490395 abandoned by Ammarpad:
Increase default thumb size to 260px on Dutch Wikipedia

Reason:
per Jforrester's comment

https://gerrit.wikimedia.org/r/490395

Ciell added a comment.May 3 2019, 4:07 PM

@Krinkle I asked for bot-assistence on the Dutch wiki for this task. Feel free to weigh in. Default thub-grootte verhogen tbv invoering VE

Bdijkstra added a subscriber: Bdijkstra.EditedMay 3 2019, 4:15 PM

Why not use 320px for thumb sizes ≤320px and let the browser do the scaling? I normally work at a browser zoom level of 110% or 125% depending on location.

And where is J(d)forrester's comment?

Akoopal added a subscriber: Akoopal.May 3 2019, 5:16 PM

How long are thumbs cached? Instead of changing all the pages, isn't it easier to just harvest all the images on these pages, make a wikipage containing all those images, and visit them so the thumbs are created (in batches of course). Then the images are created without having to change all the pages.

Why not use 320px for thumb sizes ≤320px and let the browser do the scaling?

This is out of scope for this task. There are many reasons for why MediaWiki as general software works the way it does. I am unable to find where exactly this was proposed, but it has been proposed multiple times in the past and not done for several reasons relating to the quality of user experience and web performance.

As a general rule of thumb, don't worry about performance. Having more thumbnail sizes at WMF isn't a problem right now. Switching to 260px is fine and is going to happen. We just want to generate them ahead of time, that's all.

How long are thumbs cached? Instead of changing all the pages, isn't it easier to just harvest all the images on these pages, make a wikipage containing all those images, and visit them so the thumbs are created (in batches of course). Then the images are created without having to change all the pages.

This is an interesting idea. There are many layers of caching. The first two layers (Varnish frontend, Varnish backend) have a maximum cache life between 24 hours and 7 days, with unpopular URLs generally surviving much shorter. As such, visiting them once wouldn't help in that regard.

The third layer is Swift (as written to by Thumbor), which we do not automatically delete for standard thumbnail sizes.

I think the third layer is the one that matters most. I'll let @Gilles confirm in case I missed something, but I think that means your idea could @Akoopal. Thanks!

Yes, having the thumbnails you wanted primed on a dedicated page visited once works just fine.

Change 490395 restored by Krinkle:
Increase default thumb size to 260px on Dutch Wikipedia

https://gerrit.wikimedia.org/r/490395

Change 490395 had a related patch set uploaded (by Krinkle; owner: Ammarpad):
[operations/mediawiki-config@master] Increase default thumb size to 260px on Dutch Wikipedia

https://gerrit.wikimedia.org/r/490395

And where is J(d)forrester's comment?

It's on Gerrit. The above comment is reproduced here by bot.

And where is J(d)forrester's comment?

It's on Gerrit. The above comment is reproduced here by bot.

There's a lot on Gerrit. I guess I should have asked: "Where can we read J(d)forrester's comment?"

At https://gerrit.wikimedia.org/r/490395 (you might need to click "Expand all" or "Show all" after the page loads). The comment is, in full: "Hold for performance concerns." :)

At https://gerrit.wikimedia.org/r/490395 (you might need to click "Expand all" or "Show all" after the page loads). The comment is, in full: "Hold for performance concerns." :)

Thanks. Now the thread makes a lot more sense to me.

Ciell added a comment.Wed, Jun 5, 6:02 PM

What's the status on this task?

 'wgThumbLimits' => [
 	'default' => [ 120, 150, 180, 200, 220, 250, 300, 400 ],
 	…
+	'nlwiki' => [ 120, 150, 180,      220, 260, 300, 400 ],
@Krinkle wrote:

Is there a reason to remove 200? Could we change only 250 to 260? and set default size index to 5?

I'd like to understand this before I deploy my modified version of the patch.